/* Filter.c generated by valac 0.29.3, the Vala compiler
 * generated from Filter.vala, do not modify */

/* Filter.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <json-glib/json-glib.h>
#include <json-glib/json-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>


#define TYPE_CACHEABLE (cacheable_get_type ())
#define CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CACHEABLE, Cacheable))
#define CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CACHEABLE, CacheableClass))
#define IS_CACHEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CACHEABLE))
#define IS_CACHEABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CACHEABLE))
#define CACHEABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CACHEABLE, CacheableClass))

typedef struct _Cacheable Cacheable;
typedef struct _CacheableClass CacheableClass;

#define FONT_MANAGER_TYPE_FILTER (font_manager_filter_get_type ())
#define FONT_MANAGER_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilter))
#define FONT_MANAGER_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))
#define FONT_MANAGER_IS_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_IS_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FILTER))
#define FONT_MANAGER_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FILTER, FontManagerFilterClass))

typedef struct _FontManagerFilter FontManagerFilter;
typedef struct _FontManagerFilterClass FontManagerFilterClass;
typedef struct _CacheablePrivate CacheablePrivate;
typedef struct _FontManagerFilterPrivate FontManagerFilterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

struct _Cacheable {
	GObject parent_instance;
	CacheablePrivate * priv;
};

struct _CacheableClass {
	GObjectClass parent_class;
	gboolean (*deserialize_property) (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node);
	JsonNode* (*serialize_property) (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec);
};

struct _FontManagerFilter {
	Cacheable parent_instance;
	FontManagerFilterPrivate * priv;
};

struct _FontManagerFilterClass {
	CacheableClass parent_class;
};

struct _FontManagerFilterPrivate {
	gchar* _name;
	gchar* _icon;
	gchar* _comment;
	GeeHashSet* _families;
	gint _index;
	gboolean _active;
};

struct _Block5Data {
	int _ref_count_;
	FontManagerFilter* self;
	GeeHashSet* res;
};


static gpointer font_manager_filter_parent_class = NULL;

GType cacheable_get_type (void) G_GNUC_CONST;
GType font_manager_filter_get_type (void) G_GNUC_CONST;
gint font_manager_sort_on_index (FontManagerFilter* a, FontManagerFilter* b);
gint font_manager_filter_get_index (FontManagerFilter* self);
#define FONT_MANAGER_FILTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FONT_MANAGER_TYPE_FILTER, FontManagerFilterPrivate))
enum  {
	FONT_MANAGER_FILTER_DUMMY_PROPERTY,
	FONT_MANAGER_FILTER_NAME,
	FONT_MANAGER_FILTER_ICON,
	FONT_MANAGER_FILTER_COMMENT,
	FONT_MANAGER_FILTER_FAMILIES,
	FONT_MANAGER_FILTER_INDEX,
	FONT_MANAGER_FILTER_ACTIVE
};
static gboolean font_manager_filter_real_deserialize_property (Cacheable* base, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda40_ (Block5Data* _data5_, JsonArray* array, guint index, JsonNode* node);
static void ____lambda40__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
gboolean cacheable_deserialize_property (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node);
static JsonNode* font_manager_filter_real_serialize_property (Cacheable* base, const gchar* prop_name, GValue* val, GParamSpec* pspec);
GeeHashSet* font_manager_filter_get_families (FontManagerFilter* self);
static void _vala_JsonNode_free (JsonNode* self);
JsonNode* cacheable_serialize_property (Cacheable* self, const gchar* prop_name, GValue* val, GParamSpec* pspec);
FontManagerFilter* font_manager_filter_new (void);
FontManagerFilter* font_manager_filter_construct (GType object_type);
Cacheable* cacheable_new (void);
Cacheable* cacheable_construct (GType object_type);
const gchar* font_manager_filter_get_name (FontManagerFilter* self);
void font_manager_filter_set_name (FontManagerFilter* self, const gchar* value);
const gchar* font_manager_filter_get_icon (FontManagerFilter* self);
void font_manager_filter_set_icon (FontManagerFilter* self, const gchar* value);
const gchar* font_manager_filter_get_comment (FontManagerFilter* self);
void font_manager_filter_set_comment (FontManagerFilter* self, const gchar* value);
void font_manager_filter_set_families (FontManagerFilter* self, GeeHashSet* value);
void font_manager_filter_set_index (FontManagerFilter* self, gint value);
gboolean font_manager_filter_get_active (FontManagerFilter* self);
void font_manager_filter_set_active (FontManagerFilter* self, gboolean value);
static GObject * font_manager_filter_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
gchar* get_local_time (void);
static void font_manager_filter_finalize (GObject* obj);
static void _vala_font_manager_filter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_font_manager_filter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


gint font_manager_sort_on_index (FontManagerFilter* a, FontManagerFilter* b) {
	gint result = 0;
	FontManagerFilter* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	FontManagerFilter* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = a;
	_tmp1_ = font_manager_filter_get_index (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = b;
	_tmp4_ = font_manager_filter_get_index (_tmp3_);
	_tmp5_ = _tmp4_;
	result = _tmp2_ - _tmp5_;
	return result;
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}


static void block5_data_unref (void * _userdata_) {
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		FontManagerFilter* self;
		self = _data5_->self;
		_g_object_unref0 (_data5_->res);
		_g_object_unref0 (self);
		g_slice_free (Block5Data, _data5_);
	}
}


static void ___lambda40_ (Block5Data* _data5_, JsonArray* array, guint index, JsonNode* node) {
	FontManagerFilter* self;
	GeeHashSet* _tmp0_ = NULL;
	JsonArray* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	const gchar* _tmp3_ = NULL;
	self = _data5_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = _data5_->res;
	_tmp1_ = array;
	_tmp2_ = index;
	_tmp3_ = json_array_get_string_element (_tmp1_, _tmp2_);
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp3_);
}


static void ____lambda40__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
	___lambda40_ (self, array, index_, element_node);
}


static gboolean font_manager_filter_real_deserialize_property (Cacheable* base, const gchar* prop_name, GValue* val, GParamSpec* pspec, JsonNode* node) {
	FontManagerFilter * self;
	GValue _vala_val = {0};
	gboolean result = FALSE;
	GParamSpec* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	self = (FontManagerFilter*) base;
	g_return_val_if_fail (prop_name != NULL, FALSE);
	g_return_val_if_fail (pspec != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = pspec;
	_tmp1_ = _tmp0_->value_type;
	if (_tmp1_ == GEE_TYPE_HASH_SET) {
		Block5Data* _data5_;
		GParamSpec* _tmp2_ = NULL;
		GType _tmp3_ = 0UL;
		GValue _tmp4_ = {0};
		GValue _tmp5_ = {0};
		GeeHashSet* _tmp6_ = NULL;
		JsonNode* _tmp7_ = NULL;
		JsonArray* _tmp8_ = NULL;
		GeeHashSet* _tmp9_ = NULL;
		_data5_ = g_slice_new0 (Block5Data);
		_data5_->_ref_count_ = 1;
		_data5_->self = g_object_ref (self);
		_tmp2_ = pspec;
		_tmp3_ = _tmp2_->value_type;
		g_value_init (&_tmp4_, _tmp3_);
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp4_;
		_tmp5_ = _vala_val;
		_tmp6_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL);
		_data5_->res = _tmp6_;
		_tmp7_ = node;
		_tmp8_ = json_node_get_array (_tmp7_);
		json_array_foreach_element (_tmp8_, ____lambda40__json_array_foreach, _data5_);
		_tmp9_ = _data5_->res;
		g_value_set_object (&_vala_val, (GObject*) _tmp9_);
		result = TRUE;
		block5_data_unref (_data5_);
		_data5_ = NULL;
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return result;
	} else {
		const gchar* _tmp10_ = NULL;
		GParamSpec* _tmp11_ = NULL;
		JsonNode* _tmp12_ = NULL;
		GValue _tmp13_ = {0};
		gboolean _tmp14_ = FALSE;
		_tmp10_ = prop_name;
		_tmp11_ = pspec;
		_tmp12_ = node;
		_tmp14_ = CACHEABLE_CLASS (font_manager_filter_parent_class)->deserialize_property (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CACHEABLE, Cacheable), _tmp10_, &_tmp13_, _tmp11_, _tmp12_);
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		_vala_val = _tmp13_;
		result = _tmp14_;
		if (val) {
			*val = _vala_val;
		} else {
			G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
		}
		return result;
	}
	if (val) {
		*val = _vala_val;
	} else {
		G_IS_VALUE (&_vala_val) ? (g_value_unset (&_vala_val), NULL) : NULL;
	}
}


static void _vala_JsonNode_free (JsonNode* self) {
	g_boxed_free (json_node_get_type (), self);
}


static JsonNode* font_manager_filter_real_serialize_property (Cacheable* base, const gchar* prop_name, GValue* val, GParamSpec* pspec) {
	FontManagerFilter * self;
	JsonNode* result = NULL;
	GParamSpec* _tmp0_ = NULL;
	GType _tmp1_ = 0UL;
	self = (FontManagerFilter*) base;
	g_return_val_if_fail (prop_name != NULL, NULL);
	g_return_val_if_fail (val != NULL, NULL);
	g_return_val_if_fail (pspec != NULL, NULL);
	_tmp0_ = pspec;
	_tmp1_ = _tmp0_->value_type;
	if (_tmp1_ == GEE_TYPE_HASH_SET) {
		JsonNode* node = NULL;
		JsonNode* _tmp2_ = NULL;
		JsonArray* array = NULL;
		GeeHashSet* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		JsonArray* _tmp6_ = NULL;
		JsonNode* _tmp15_ = NULL;
		JsonArray* _tmp16_ = NULL;
		_tmp2_ = json_node_new (JSON_NODE_ARRAY);
		node = _tmp2_;
		_tmp3_ = self->priv->_families;
		_tmp4_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = json_array_sized_new ((guint) _tmp5_);
		array = _tmp6_;
		{
			GeeIterator* _font_it = NULL;
			GeeHashSet* _tmp7_ = NULL;
			GeeIterator* _tmp8_ = NULL;
			_tmp7_ = self->priv->_families;
			_tmp8_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp7_);
			_font_it = _tmp8_;
			while (TRUE) {
				GeeIterator* _tmp9_ = NULL;
				gboolean _tmp10_ = FALSE;
				gchar* font = NULL;
				GeeIterator* _tmp11_ = NULL;
				gpointer _tmp12_ = NULL;
				JsonArray* _tmp13_ = NULL;
				const gchar* _tmp14_ = NULL;
				_tmp9_ = _font_it;
				_tmp10_ = gee_iterator_next (_tmp9_);
				if (!_tmp10_) {
					break;
				}
				_tmp11_ = _font_it;
				_tmp12_ = gee_iterator_get (_tmp11_);
				font = (gchar*) _tmp12_;
				_tmp13_ = array;
				_tmp14_ = font;
				json_array_add_string_element (_tmp13_, _tmp14_);
				_g_free0 (font);
			}
			_g_object_unref0 (_font_it);
		}
		_tmp15_ = node;
		_tmp16_ = array;
		json_node_set_array (_tmp15_, _tmp16_);
		result = node;
		_json_array_unref0 (array);
		return result;
	} else {
		const gchar* _tmp17_ = NULL;
		GValue _tmp18_ = {0};
		GParamSpec* _tmp19_ = NULL;
		JsonNode* _tmp20_ = NULL;
		_tmp17_ = prop_name;
		_tmp18_ = *val;
		_tmp19_ = pspec;
		_tmp20_ = CACHEABLE_CLASS (font_manager_filter_parent_class)->serialize_property (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_CACHEABLE, Cacheable), _tmp17_, &_tmp18_, _tmp19_);
		result = _tmp20_;
		return result;
	}
}


FontManagerFilter* font_manager_filter_construct (GType object_type) {
	FontManagerFilter * self = NULL;
	self = (FontManagerFilter*) cacheable_construct (object_type);
	return self;
}


FontManagerFilter* font_manager_filter_new (void) {
	return font_manager_filter_construct (FONT_MANAGER_TYPE_FILTER);
}


const gchar* font_manager_filter_get_name (FontManagerFilter* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void font_manager_filter_set_name (FontManagerFilter* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


const gchar* font_manager_filter_get_icon (FontManagerFilter* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_icon;
	result = _tmp0_;
	return result;
}


void font_manager_filter_set_icon (FontManagerFilter* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_icon);
	self->priv->_icon = _tmp1_;
	g_object_notify ((GObject *) self, "icon");
}


const gchar* font_manager_filter_get_comment (FontManagerFilter* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_comment;
	result = _tmp0_;
	return result;
}


void font_manager_filter_set_comment (FontManagerFilter* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_comment);
	self->priv->_comment = _tmp1_;
	g_object_notify ((GObject *) self, "comment");
}


GeeHashSet* font_manager_filter_get_families (FontManagerFilter* self) {
	GeeHashSet* result;
	GeeHashSet* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_families;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void font_manager_filter_set_families (FontManagerFilter* self, GeeHashSet* value) {
	GeeHashSet* _tmp0_ = NULL;
	GeeHashSet* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_families);
	self->priv->_families = _tmp1_;
	g_object_notify ((GObject *) self, "families");
}


gint font_manager_filter_get_index (FontManagerFilter* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_index;
	result = _tmp0_;
	return result;
}


void font_manager_filter_set_index (FontManagerFilter* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_index = _tmp0_;
	g_object_notify ((GObject *) self, "index");
}


gboolean font_manager_filter_get_active (FontManagerFilter* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_active;
	result = _tmp0_;
	return result;
}


void font_manager_filter_set_active (FontManagerFilter* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_active = _tmp0_;
	g_object_notify ((GObject *) self, "active");
}


static GObject * font_manager_filter_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerFilter * self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	parent_class = G_OBJECT_CLASS (font_manager_filter_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_FILTER, FontManagerFilter);
	_tmp0_ = _ ("Created : %s");
	_tmp1_ = get_local_time ();
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strdup_printf (_tmp0_, _tmp2_);
	_tmp4_ = _tmp3_;
	font_manager_filter_set_comment (self, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	return obj;
}


static void font_manager_filter_class_init (FontManagerFilterClass * klass) {
	font_manager_filter_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FontManagerFilterPrivate));
	((CacheableClass *) klass)->deserialize_property = font_manager_filter_real_deserialize_property;
	((CacheableClass *) klass)->serialize_property = font_manager_filter_real_serialize_property;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_filter_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_filter_set_property;
	G_OBJECT_CLASS (klass)->constructor = font_manager_filter_constructor;
	G_OBJECT_CLASS (klass)->finalize = font_manager_filter_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_ICON, g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_COMMENT, g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_FAMILIES, g_param_spec_object ("families", "families", "families", GEE_TYPE_HASH_SET, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_INDEX, g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FILTER_ACTIVE, g_param_spec_boolean ("active", "active", "active", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void font_manager_filter_instance_init (FontManagerFilter * self) {
	self->priv = FONT_MANAGER_FILTER_GET_PRIVATE (self);
	self->priv->_icon = NULL;
	self->priv->_index = 0;
	self->priv->_active = TRUE;
}


static void font_manager_filter_finalize (GObject* obj) {
	FontManagerFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_FILTER, FontManagerFilter);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->_icon);
	_g_free0 (self->priv->_comment);
	_g_object_unref0 (self->priv->_families);
	G_OBJECT_CLASS (font_manager_filter_parent_class)->finalize (obj);
}


GType font_manager_filter_get_type (void) {
	static volatile gsize font_manager_filter_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_filter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerFilter), 0, (GInstanceInitFunc) font_manager_filter_instance_init, NULL };
		GType font_manager_filter_type_id;
		font_manager_filter_type_id = g_type_register_static (TYPE_CACHEABLE, "FontManagerFilter", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_filter_type_id__volatile, font_manager_filter_type_id);
	}
	return font_manager_filter_type_id__volatile;
}


static void _vala_font_manager_filter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FontManagerFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FILTER, FontManagerFilter);
	switch (property_id) {
		case FONT_MANAGER_FILTER_NAME:
		g_value_set_string (value, font_manager_filter_get_name (self));
		break;
		case FONT_MANAGER_FILTER_ICON:
		g_value_set_string (value, font_manager_filter_get_icon (self));
		break;
		case FONT_MANAGER_FILTER_COMMENT:
		g_value_set_string (value, font_manager_filter_get_comment (self));
		break;
		case FONT_MANAGER_FILTER_FAMILIES:
		g_value_set_object (value, font_manager_filter_get_families (self));
		break;
		case FONT_MANAGER_FILTER_INDEX:
		g_value_set_int (value, font_manager_filter_get_index (self));
		break;
		case FONT_MANAGER_FILTER_ACTIVE:
		g_value_set_boolean (value, font_manager_filter_get_active (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_font_manager_filter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FontManagerFilter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FILTER, FontManagerFilter);
	switch (property_id) {
		case FONT_MANAGER_FILTER_NAME:
		font_manager_filter_set_name (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_FILTER_ICON:
		font_manager_filter_set_icon (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_FILTER_COMMENT:
		font_manager_filter_set_comment (self, g_value_get_string (value));
		break;
		case FONT_MANAGER_FILTER_FAMILIES:
		font_manager_filter_set_families (self, g_value_get_object (value));
		break;
		case FONT_MANAGER_FILTER_INDEX:
		font_manager_filter_set_index (self, g_value_get_int (value));
		break;
		case FONT_MANAGER_FILTER_ACTIVE:
		font_manager_filter_set_active (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



