/* DefaultProperties.c generated by valac 0.29.3, the Vala compiler
 * generated from DefaultProperties.vala, do not modify */

/* DefaultProperties.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/tree.h>
#include <libxml/xmlwriter.h>
#include <gee.h>


#define FONT_CONFIG_TYPE_PROPERTIES (font_config_properties_get_type ())
#define FONT_CONFIG_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_PROPERTIES, FontConfigProperties))
#define FONT_CONFIG_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_PROPERTIES, FontConfigPropertiesClass))
#define FONT_CONFIG_IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_PROPERTIES))
#define FONT_CONFIG_IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_PROPERTIES))
#define FONT_CONFIG_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_PROPERTIES, FontConfigPropertiesClass))

typedef struct _FontConfigProperties FontConfigProperties;
typedef struct _FontConfigPropertiesClass FontConfigPropertiesClass;
typedef struct _FontConfigPropertiesPrivate FontConfigPropertiesPrivate;
typedef xmlTextWriter FontConfigXmlWriter;

#define FONT_CONFIG_TYPE_DEFAULT_PROPERTIES (font_config_default_properties_get_type ())
#define FONT_CONFIG_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultProperties))
#define FONT_CONFIG_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultPropertiesClass))
#define FONT_CONFIG_IS_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES))
#define FONT_CONFIG_IS_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES))
#define FONT_CONFIG_DEFAULT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultPropertiesClass))

typedef struct _FontConfigDefaultProperties FontConfigDefaultProperties;
typedef struct _FontConfigDefaultPropertiesClass FontConfigDefaultPropertiesClass;
typedef struct _FontConfigDefaultPropertiesPrivate FontConfigDefaultPropertiesPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FontConfigProperties {
	GObject parent_instance;
	FontConfigPropertiesPrivate * priv;
	GeeArrayList* skip_property_assignment;
};

struct _FontConfigPropertiesClass {
	GObjectClass parent_class;
	gchar* (*get_config_file) (FontConfigProperties* self);
	void (*reset_properties) (FontConfigProperties* self);
	gboolean (*load) (FontConfigProperties* self, const gchar* target);
	gboolean (*save) (FontConfigProperties* self);
	gboolean (*discard) (FontConfigProperties* self);
	void (*load_assignments) (FontConfigProperties* self, const gchar* target_file);
	void (*parse_edit_node) (FontConfigProperties* self, xmlNode* iter);
	void (*parse_test_node) (FontConfigProperties* self, xmlNode* iter);
	void (*parse_node) (FontConfigProperties* self, xmlNode* node);
	gchar* (*type_to_string) (FontConfigProperties* self, GType t);
	gchar* (*value_to_string) (FontConfigProperties* self, const gchar* type, GValue* val);
	void (*write_assignments) (FontConfigProperties* self, FontConfigXmlWriter* writer);
	void (*write_match_criteria) (FontConfigProperties* self, FontConfigXmlWriter* writer);
};

struct _FontConfigDefaultProperties {
	FontConfigProperties parent_instance;
	FontConfigDefaultPropertiesPrivate * priv;
};

struct _FontConfigDefaultPropertiesClass {
	FontConfigPropertiesClass parent_class;
};

struct _FontConfigDefaultPropertiesPrivate {
	gint _hintstyle;
	gboolean _antialias;
	gboolean _hinting;
	gboolean _autohint;
	gboolean _embeddedbitmap;
};


static gpointer font_config_default_properties_parent_class = NULL;

GType font_config_properties_get_type (void) G_GNUC_CONST;
GType font_config_default_properties_get_type (void) G_GNUC_CONST;
#define FONT_CONFIG_DEFAULT_PROPERTIES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultPropertiesPrivate))
enum  {
	FONT_CONFIG_DEFAULT_PROPERTIES_DUMMY_PROPERTY,
	FONT_CONFIG_DEFAULT_PROPERTIES_HINTSTYLE,
	FONT_CONFIG_DEFAULT_PROPERTIES_ANTIALIAS,
	FONT_CONFIG_DEFAULT_PROPERTIES_HINTING,
	FONT_CONFIG_DEFAULT_PROPERTIES_AUTOHINT,
	FONT_CONFIG_DEFAULT_PROPERTIES_EMBEDDEDBITMAP
};
FontConfigDefaultProperties* font_config_default_properties_new (void);
FontConfigDefaultProperties* font_config_default_properties_construct (GType object_type);
FontConfigProperties* font_config_properties_new (void);
FontConfigProperties* font_config_properties_construct (GType object_type);
gchar* font_config_get_config_dir (void);
void font_config_properties_set_target_file (FontConfigProperties* self, const gchar* value);
gboolean font_config_properties_load (FontConfigProperties* self, const gchar* target);
static void font_config_default_properties_real_reset_properties (FontConfigProperties* base);
void font_config_default_properties_set_hintstyle (FontConfigDefaultProperties* self, gint value);
void font_config_default_properties_set_antialias (FontConfigDefaultProperties* self, gboolean value);
void font_config_default_properties_set_hinting (FontConfigDefaultProperties* self, gboolean value);
void font_config_default_properties_set_autohint (FontConfigDefaultProperties* self, gboolean value);
void font_config_default_properties_set_embeddedbitmap (FontConfigDefaultProperties* self, gboolean value);
gint font_config_default_properties_get_hintstyle (FontConfigDefaultProperties* self);
gboolean font_config_default_properties_get_antialias (FontConfigDefaultProperties* self);
gboolean font_config_default_properties_get_hinting (FontConfigDefaultProperties* self);
gboolean font_config_default_properties_get_autohint (FontConfigDefaultProperties* self);
gboolean font_config_default_properties_get_embeddedbitmap (FontConfigDefaultProperties* self);
static void font_config_default_properties_finalize (GObject* obj);
static void _vala_font_config_default_properties_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_font_config_default_properties_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


FontConfigDefaultProperties* font_config_default_properties_construct (GType object_type) {
	FontConfigDefaultProperties * self = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	self = (FontConfigDefaultProperties*) font_config_properties_construct (object_type);
	_tmp0_ = ((FontConfigProperties*) self)->skip_property_assignment;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, "family");
	_tmp1_ = ((FontConfigProperties*) self)->skip_property_assignment;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, "font");
	_tmp2_ = font_config_get_config_dir ();
	_tmp3_ = _tmp2_;
	_tmp4_ = g_build_filename (_tmp3_, "19-DefaultProperties.conf", NULL);
	_tmp5_ = _tmp4_;
	font_config_properties_set_target_file ((FontConfigProperties*) self, _tmp5_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	font_config_properties_load ((FontConfigProperties*) self, NULL);
	return self;
}


FontConfigDefaultProperties* font_config_default_properties_new (void) {
	return font_config_default_properties_construct (FONT_CONFIG_TYPE_DEFAULT_PROPERTIES);
}


static void font_config_default_properties_real_reset_properties (FontConfigProperties* base) {
	FontConfigDefaultProperties * self;
	self = (FontConfigDefaultProperties*) base;
	font_config_default_properties_set_hintstyle (self, 1);
	font_config_default_properties_set_antialias (self, TRUE);
	font_config_default_properties_set_hinting (self, TRUE);
	font_config_default_properties_set_autohint (self, FALSE);
	font_config_default_properties_set_embeddedbitmap (self, FALSE);
	return;
}


gint font_config_default_properties_get_hintstyle (FontConfigDefaultProperties* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_hintstyle;
	result = _tmp0_;
	return result;
}


void font_config_default_properties_set_hintstyle (FontConfigDefaultProperties* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_hintstyle = _tmp0_;
	g_object_notify ((GObject *) self, "hintstyle");
}


gboolean font_config_default_properties_get_antialias (FontConfigDefaultProperties* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_antialias;
	result = _tmp0_;
	return result;
}


void font_config_default_properties_set_antialias (FontConfigDefaultProperties* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_antialias = _tmp0_;
	g_object_notify ((GObject *) self, "antialias");
}


gboolean font_config_default_properties_get_hinting (FontConfigDefaultProperties* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_hinting;
	result = _tmp0_;
	return result;
}


void font_config_default_properties_set_hinting (FontConfigDefaultProperties* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_hinting = _tmp0_;
	g_object_notify ((GObject *) self, "hinting");
}


gboolean font_config_default_properties_get_autohint (FontConfigDefaultProperties* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_autohint;
	result = _tmp0_;
	return result;
}


void font_config_default_properties_set_autohint (FontConfigDefaultProperties* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_autohint = _tmp0_;
	g_object_notify ((GObject *) self, "autohint");
}


gboolean font_config_default_properties_get_embeddedbitmap (FontConfigDefaultProperties* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_embeddedbitmap;
	result = _tmp0_;
	return result;
}


void font_config_default_properties_set_embeddedbitmap (FontConfigDefaultProperties* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_embeddedbitmap = _tmp0_;
	g_object_notify ((GObject *) self, "embeddedbitmap");
}


static void font_config_default_properties_class_init (FontConfigDefaultPropertiesClass * klass) {
	font_config_default_properties_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FontConfigDefaultPropertiesPrivate));
	((FontConfigPropertiesClass *) klass)->reset_properties = font_config_default_properties_real_reset_properties;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_config_default_properties_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_config_default_properties_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_config_default_properties_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DEFAULT_PROPERTIES_HINTSTYLE, g_param_spec_int ("hintstyle", "hintstyle", "hintstyle", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DEFAULT_PROPERTIES_ANTIALIAS, g_param_spec_boolean ("antialias", "antialias", "antialias", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DEFAULT_PROPERTIES_HINTING, g_param_spec_boolean ("hinting", "hinting", "hinting", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DEFAULT_PROPERTIES_AUTOHINT, g_param_spec_boolean ("autohint", "autohint", "autohint", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DEFAULT_PROPERTIES_EMBEDDEDBITMAP, g_param_spec_boolean ("embeddedbitmap", "embeddedbitmap", "embeddedbitmap", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void font_config_default_properties_instance_init (FontConfigDefaultProperties * self) {
	self->priv = FONT_CONFIG_DEFAULT_PROPERTIES_GET_PRIVATE (self);
	self->priv->_hintstyle = 1;
	self->priv->_antialias = TRUE;
	self->priv->_hinting = TRUE;
	self->priv->_autohint = FALSE;
	self->priv->_embeddedbitmap = FALSE;
}


static void font_config_default_properties_finalize (GObject* obj) {
	FontConfigDefaultProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultProperties);
	G_OBJECT_CLASS (font_config_default_properties_parent_class)->finalize (obj);
}


GType font_config_default_properties_get_type (void) {
	static volatile gsize font_config_default_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_default_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontConfigDefaultPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_config_default_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontConfigDefaultProperties), 0, (GInstanceInitFunc) font_config_default_properties_instance_init, NULL };
		GType font_config_default_properties_type_id;
		font_config_default_properties_type_id = g_type_register_static (FONT_CONFIG_TYPE_PROPERTIES, "FontConfigDefaultProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_config_default_properties_type_id__volatile, font_config_default_properties_type_id);
	}
	return font_config_default_properties_type_id__volatile;
}


static void _vala_font_config_default_properties_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FontConfigDefaultProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultProperties);
	switch (property_id) {
		case FONT_CONFIG_DEFAULT_PROPERTIES_HINTSTYLE:
		g_value_set_int (value, font_config_default_properties_get_hintstyle (self));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_ANTIALIAS:
		g_value_set_boolean (value, font_config_default_properties_get_antialias (self));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_HINTING:
		g_value_set_boolean (value, font_config_default_properties_get_hinting (self));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_AUTOHINT:
		g_value_set_boolean (value, font_config_default_properties_get_autohint (self));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_EMBEDDEDBITMAP:
		g_value_set_boolean (value, font_config_default_properties_get_embeddedbitmap (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_font_config_default_properties_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FontConfigDefaultProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_DEFAULT_PROPERTIES, FontConfigDefaultProperties);
	switch (property_id) {
		case FONT_CONFIG_DEFAULT_PROPERTIES_HINTSTYLE:
		font_config_default_properties_set_hintstyle (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_ANTIALIAS:
		font_config_default_properties_set_antialias (self, g_value_get_boolean (value));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_HINTING:
		font_config_default_properties_set_hinting (self, g_value_get_boolean (value));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_AUTOHINT:
		font_config_default_properties_set_autohint (self, g_value_get_boolean (value));
		break;
		case FONT_CONFIG_DEFAULT_PROPERTIES_EMBEDDEDBITMAP:
		font_config_default_properties_set_embeddedbitmap (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



