/* DisplayProperties.c generated by valac 0.29.3, the Vala compiler
 * generated from DisplayProperties.vala, do not modify */

/* DisplayProperties.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/tree.h>
#include <libxml/xmlwriter.h>
#include <gee.h>
#include <float.h>
#include <math.h>


#define FONT_CONFIG_TYPE_PROPERTIES (font_config_properties_get_type ())
#define FONT_CONFIG_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_PROPERTIES, FontConfigProperties))
#define FONT_CONFIG_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_PROPERTIES, FontConfigPropertiesClass))
#define FONT_CONFIG_IS_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_PROPERTIES))
#define FONT_CONFIG_IS_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_PROPERTIES))
#define FONT_CONFIG_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_PROPERTIES, FontConfigPropertiesClass))

typedef struct _FontConfigProperties FontConfigProperties;
typedef struct _FontConfigPropertiesClass FontConfigPropertiesClass;
typedef struct _FontConfigPropertiesPrivate FontConfigPropertiesPrivate;
typedef xmlTextWriter FontConfigXmlWriter;

#define FONT_CONFIG_TYPE_DISPLAY_PROPERTIES (font_config_display_properties_get_type ())
#define FONT_CONFIG_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayProperties))
#define FONT_CONFIG_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayPropertiesClass))
#define FONT_CONFIG_IS_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES))
#define FONT_CONFIG_IS_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES))
#define FONT_CONFIG_DISPLAY_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayPropertiesClass))

typedef struct _FontConfigDisplayProperties FontConfigDisplayProperties;
typedef struct _FontConfigDisplayPropertiesClass FontConfigDisplayPropertiesClass;
typedef struct _FontConfigDisplayPropertiesPrivate FontConfigDisplayPropertiesPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _FontConfigProperties {
	GObject parent_instance;
	FontConfigPropertiesPrivate * priv;
	GeeArrayList* skip_property_assignment;
};

struct _FontConfigPropertiesClass {
	GObjectClass parent_class;
	gchar* (*get_config_file) (FontConfigProperties* self);
	void (*reset_properties) (FontConfigProperties* self);
	gboolean (*load) (FontConfigProperties* self, const gchar* target);
	gboolean (*save) (FontConfigProperties* self);
	gboolean (*discard) (FontConfigProperties* self);
	void (*load_assignments) (FontConfigProperties* self, const gchar* target_file);
	void (*parse_edit_node) (FontConfigProperties* self, xmlNode* iter);
	void (*parse_test_node) (FontConfigProperties* self, xmlNode* iter);
	void (*parse_node) (FontConfigProperties* self, xmlNode* node);
	gchar* (*type_to_string) (FontConfigProperties* self, GType t);
	gchar* (*value_to_string) (FontConfigProperties* self, const gchar* type, GValue* val);
	void (*write_assignments) (FontConfigProperties* self, FontConfigXmlWriter* writer);
	void (*write_match_criteria) (FontConfigProperties* self, FontConfigXmlWriter* writer);
};

struct _FontConfigDisplayProperties {
	FontConfigProperties parent_instance;
	FontConfigDisplayPropertiesPrivate * priv;
};

struct _FontConfigDisplayPropertiesClass {
	FontConfigPropertiesClass parent_class;
};

struct _FontConfigDisplayPropertiesPrivate {
	gint _rgba;
	gint _lcdfilter;
	gdouble _scale;
	gdouble _dpi;
};


static gpointer font_config_display_properties_parent_class = NULL;

GType font_config_properties_get_type (void) G_GNUC_CONST;
GType font_config_display_properties_get_type (void) G_GNUC_CONST;
#define FONT_CONFIG_DISPLAY_PROPERTIES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayPropertiesPrivate))
enum  {
	FONT_CONFIG_DISPLAY_PROPERTIES_DUMMY_PROPERTY,
	FONT_CONFIG_DISPLAY_PROPERTIES_RGBA,
	FONT_CONFIG_DISPLAY_PROPERTIES_LCDFILTER,
	FONT_CONFIG_DISPLAY_PROPERTIES_SCALE,
	FONT_CONFIG_DISPLAY_PROPERTIES_DPI
};
FontConfigDisplayProperties* font_config_display_properties_new (void);
FontConfigDisplayProperties* font_config_display_properties_construct (GType object_type);
FontConfigProperties* font_config_properties_new (void);
FontConfigProperties* font_config_properties_construct (GType object_type);
gchar* font_config_get_config_dir (void);
void font_config_properties_set_target_file (FontConfigProperties* self, const gchar* value);
gboolean font_config_properties_load (FontConfigProperties* self, const gchar* target);
static void font_config_display_properties_real_reset_properties (FontConfigProperties* base);
void font_config_display_properties_set_rgba (FontConfigDisplayProperties* self, gint value);
void font_config_display_properties_set_lcdfilter (FontConfigDisplayProperties* self, gint value);
void font_config_display_properties_set_scale (FontConfigDisplayProperties* self, gdouble value);
void font_config_display_properties_set_dpi (FontConfigDisplayProperties* self, gdouble value);
gint font_config_display_properties_get_rgba (FontConfigDisplayProperties* self);
gint font_config_display_properties_get_lcdfilter (FontConfigDisplayProperties* self);
gdouble font_config_display_properties_get_scale (FontConfigDisplayProperties* self);
gdouble font_config_display_properties_get_dpi (FontConfigDisplayProperties* self);
static void font_config_display_properties_finalize (GObject* obj);
static void _vala_font_config_display_properties_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_font_config_display_properties_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


FontConfigDisplayProperties* font_config_display_properties_construct (GType object_type) {
	FontConfigDisplayProperties * self = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	self = (FontConfigDisplayProperties*) font_config_properties_construct (object_type);
	_tmp0_ = font_config_get_config_dir ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_build_filename (_tmp1_, "19-DisplayProperties.conf", NULL);
	_tmp3_ = _tmp2_;
	font_config_properties_set_target_file ((FontConfigProperties*) self, _tmp3_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	font_config_properties_load ((FontConfigProperties*) self, NULL);
	return self;
}


FontConfigDisplayProperties* font_config_display_properties_new (void) {
	return font_config_display_properties_construct (FONT_CONFIG_TYPE_DISPLAY_PROPERTIES);
}


static void font_config_display_properties_real_reset_properties (FontConfigProperties* base) {
	FontConfigDisplayProperties * self;
	self = (FontConfigDisplayProperties*) base;
	font_config_display_properties_set_rgba (self, 1);
	font_config_display_properties_set_lcdfilter (self, 1);
	font_config_display_properties_set_scale (self, 1.00);
	font_config_display_properties_set_dpi (self, (gdouble) 96);
	return;
}


gint font_config_display_properties_get_rgba (FontConfigDisplayProperties* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_rgba;
	result = _tmp0_;
	return result;
}


void font_config_display_properties_set_rgba (FontConfigDisplayProperties* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_rgba = _tmp0_;
	g_object_notify ((GObject *) self, "rgba");
}


gint font_config_display_properties_get_lcdfilter (FontConfigDisplayProperties* self) {
	gint result;
	gint _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_lcdfilter;
	result = _tmp0_;
	return result;
}


void font_config_display_properties_set_lcdfilter (FontConfigDisplayProperties* self, gint value) {
	gint _tmp0_ = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_lcdfilter = _tmp0_;
	g_object_notify ((GObject *) self, "lcdfilter");
}


gdouble font_config_display_properties_get_scale (FontConfigDisplayProperties* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_scale;
	result = _tmp0_;
	return result;
}


void font_config_display_properties_set_scale (FontConfigDisplayProperties* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_scale = _tmp0_;
	g_object_notify ((GObject *) self, "scale");
}


gdouble font_config_display_properties_get_dpi (FontConfigDisplayProperties* self) {
	gdouble result;
	gdouble _tmp0_ = 0.0;
	g_return_val_if_fail (self != NULL, 0.0);
	_tmp0_ = self->priv->_dpi;
	result = _tmp0_;
	return result;
}


void font_config_display_properties_set_dpi (FontConfigDisplayProperties* self, gdouble value) {
	gdouble _tmp0_ = 0.0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_dpi = _tmp0_;
	g_object_notify ((GObject *) self, "dpi");
}


static void font_config_display_properties_class_init (FontConfigDisplayPropertiesClass * klass) {
	font_config_display_properties_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FontConfigDisplayPropertiesPrivate));
	((FontConfigPropertiesClass *) klass)->reset_properties = font_config_display_properties_real_reset_properties;
	G_OBJECT_CLASS (klass)->get_property = _vala_font_config_display_properties_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_font_config_display_properties_set_property;
	G_OBJECT_CLASS (klass)->finalize = font_config_display_properties_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DISPLAY_PROPERTIES_RGBA, g_param_spec_int ("rgba", "rgba", "rgba", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DISPLAY_PROPERTIES_LCDFILTER, g_param_spec_int ("lcdfilter", "lcdfilter", "lcdfilter", G_MININT, G_MAXINT, 1, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DISPLAY_PROPERTIES_SCALE, g_param_spec_double ("scale", "scale", "scale", -G_MAXDOUBLE, G_MAXDOUBLE, 1.00, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_CONFIG_DISPLAY_PROPERTIES_DPI, g_param_spec_double ("dpi", "dpi", "dpi", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 96, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void font_config_display_properties_instance_init (FontConfigDisplayProperties * self) {
	self->priv = FONT_CONFIG_DISPLAY_PROPERTIES_GET_PRIVATE (self);
	self->priv->_rgba = 1;
	self->priv->_lcdfilter = 1;
	self->priv->_scale = 1.00;
	self->priv->_dpi = (gdouble) 96;
}


static void font_config_display_properties_finalize (GObject* obj) {
	FontConfigDisplayProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayProperties);
	G_OBJECT_CLASS (font_config_display_properties_parent_class)->finalize (obj);
}


GType font_config_display_properties_get_type (void) {
	static volatile gsize font_config_display_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_config_display_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontConfigDisplayPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_config_display_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontConfigDisplayProperties), 0, (GInstanceInitFunc) font_config_display_properties_instance_init, NULL };
		GType font_config_display_properties_type_id;
		font_config_display_properties_type_id = g_type_register_static (FONT_CONFIG_TYPE_PROPERTIES, "FontConfigDisplayProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_config_display_properties_type_id__volatile, font_config_display_properties_type_id);
	}
	return font_config_display_properties_type_id__volatile;
}


static void _vala_font_config_display_properties_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FontConfigDisplayProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayProperties);
	switch (property_id) {
		case FONT_CONFIG_DISPLAY_PROPERTIES_RGBA:
		g_value_set_int (value, font_config_display_properties_get_rgba (self));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_LCDFILTER:
		g_value_set_int (value, font_config_display_properties_get_lcdfilter (self));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_SCALE:
		g_value_set_double (value, font_config_display_properties_get_scale (self));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_DPI:
		g_value_set_double (value, font_config_display_properties_get_dpi (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_font_config_display_properties_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FontConfigDisplayProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_CONFIG_TYPE_DISPLAY_PROPERTIES, FontConfigDisplayProperties);
	switch (property_id) {
		case FONT_CONFIG_DISPLAY_PROPERTIES_RGBA:
		font_config_display_properties_set_rgba (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_LCDFILTER:
		font_config_display_properties_set_lcdfilter (self, g_value_get_int (value));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_SCALE:
		font_config_display_properties_set_scale (self, g_value_get_double (value));
		break;
		case FONT_CONFIG_DISPLAY_PROPERTIES_DPI:
		font_config_display_properties_set_dpi (self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



