/* XmlWriter.c generated by valac 0.29.3, the Vala compiler
 * generated from XmlWriter.vala, do not modify */

/* XmlWriter.vala
 *
 * Copyright (C) 2009 - 2015 Jerry Casiano
 *
 * This file is part of Font Manager.
 *
 * Font Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Font Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Font Manager.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 *        Jerry Casiano <JerryCasiano@gmail.com>
*/

#include <glib.h>
#include <glib-object.h>
#include <libxml/xmlwriter.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

typedef xmlTextWriter FontConfigXmlWriter;



FontConfigXmlWriter* font_config_xml_writer_new (const gchar* filepath);
FontConfigXmlWriter* font_config_xml_writer_new (const gchar* filepath);
void font_config_xml_writer_write_assignment (FontConfigXmlWriter* self, const gchar* name, const gchar* type, const gchar* val);
void font_config_xml_writer_write_comparison (FontConfigXmlWriter* self, const gchar* name, const gchar* test, const gchar* type, const gchar* val);
void font_config_xml_writer_write_family_patelt (FontConfigXmlWriter* self, const gchar* family);
void font_config_xml_writer_write_patelt (FontConfigXmlWriter* self, const gchar* name, const gchar* element_type, const gchar* val);
void font_config_xml_writer_start_selection (FontConfigXmlWriter* self, const gchar* selection_type);
void font_config_xml_writer_end_selection (FontConfigXmlWriter* self);
void font_config_xml_writer_close (FontConfigXmlWriter* self);


FontConfigXmlWriter* font_config_xml_writer_new (const gchar* filepath) {
	FontConfigXmlWriter* self;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (filepath != NULL, NULL);
	_tmp0_ = filepath;
	self = (FontConfigXmlWriter*) xmlNewTextWriterFilename (_tmp0_, FALSE);
	xmlTextWriterSetIndent ((xmlTextWriter*) self, TRUE);
	xmlTextWriterSetIndentString ((xmlTextWriter*) self, (xmlChar*) "  ");
	xmlTextWriterStartDocument ((xmlTextWriter*) self, NULL, NULL, NULL);
	xmlTextWriterWriteString ((xmlTextWriter*) self, (xmlChar*) "<!DOCTYPE fontconfig SYSTEM \"fonts.dtd\">\n");
	_tmp1_ = _ (" Generated by Font Manager. Do NOT edit this file. ");
	xmlTextWriterWriteComment ((xmlTextWriter*) self, (xmlChar*) _tmp1_);
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "fontconfig");
	return self;
}


void font_config_xml_writer_write_assignment (FontConfigXmlWriter* self, const gchar* name, const gchar* type, const gchar* val) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (val != NULL);
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "edit");
	_tmp0_ = name;
	xmlTextWriterWriteAttribute ((xmlTextWriter*) self, (xmlChar*) "name", (xmlChar*) _tmp0_);
	xmlTextWriterWriteAttribute ((xmlTextWriter*) self, (xmlChar*) "mode", (xmlChar*) "assign");
	_tmp1_ = type;
	_tmp2_ = val;
	xmlTextWriterWriteElement ((xmlTextWriter*) self, (xmlChar*) _tmp1_, (xmlChar*) _tmp2_);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	return;
}


void font_config_xml_writer_write_comparison (FontConfigXmlWriter* self, const gchar* name, const gchar* test, const gchar* type, const gchar* val) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (test != NULL);
	g_return_if_fail (type != NULL);
	g_return_if_fail (val != NULL);
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "test");
	_tmp0_ = name;
	xmlTextWriterWriteAttribute ((xmlTextWriter*) self, (xmlChar*) "name", (xmlChar*) _tmp0_);
	_tmp1_ = test;
	xmlTextWriterWriteAttribute ((xmlTextWriter*) self, (xmlChar*) "compare", (xmlChar*) _tmp1_);
	_tmp2_ = type;
	_tmp3_ = val;
	xmlTextWriterWriteElement ((xmlTextWriter*) self, (xmlChar*) _tmp2_, (xmlChar*) _tmp3_);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	return;
}


void font_config_xml_writer_write_family_patelt (FontConfigXmlWriter* self, const gchar* family) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (family != NULL);
	_tmp0_ = family;
	font_config_xml_writer_write_patelt (self, "family", "string", _tmp0_);
	return;
}


void font_config_xml_writer_write_patelt (FontConfigXmlWriter* self, const gchar* name, const gchar* element_type, const gchar* val) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (element_type != NULL);
	g_return_if_fail (val != NULL);
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "pattern");
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "patelt");
	_tmp0_ = name;
	xmlTextWriterWriteAttribute ((xmlTextWriter*) self, (xmlChar*) "name", (xmlChar*) _tmp0_);
	_tmp1_ = element_type;
	_tmp2_ = val;
	xmlTextWriterWriteElement ((xmlTextWriter*) self, (xmlChar*) _tmp1_, (xmlChar*) _tmp2_);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	return;
}


void font_config_xml_writer_start_selection (FontConfigXmlWriter* self, const gchar* selection_type) {
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (selection_type != NULL);
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) "selectfont");
	_tmp0_ = selection_type;
	xmlTextWriterStartElement ((xmlTextWriter*) self, (xmlChar*) _tmp0_);
	return;
}


void font_config_xml_writer_end_selection (FontConfigXmlWriter* self) {
	g_return_if_fail (self != NULL);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	return;
}


void font_config_xml_writer_close (FontConfigXmlWriter* self) {
	g_return_if_fail (self != NULL);
	xmlTextWriterEndElement ((xmlTextWriter*) self);
	xmlTextWriterEndDocument ((xmlTextWriter*) self);
	xmlTextWriterFlush ((xmlTextWriter*) self);
	return;
}



